<?php

/**
 * returns javascript code needed to lod tag manager
 *
 * @since  2017-09-25

 * @author Patrick Forget <patforg@geekpad.ca>
 */
function oboxads_head_script() {

  $plugin = OboxmediaAdsPlugin::get_instance();

  $tagVersion = $plugin->options['tagVersion'];
  $tagVersion = apply_filters('oboxads_tag_version', $tagVersion);
  if (isset($_GET['oboxads_tag_version'])) {
    $tagVersion = $_GET['oboxads_tag_version'];
  } //if

  if (defined('APPLICATION_ENV') && APPLICATION_ENV === 'DEV') {
    #$baseURL = "//local.cdn.oboxads.com/$tagVersion";
    $baseURL = "//static.bigpipes.co";
  } else {
    #$baseURL = "//cdn.oboxads.com/$tagVersion";
    $baseURL = "//static.bigpipes.co";
  } //if

  $manualInit = $plugin->options['manual_init'];
  $manualInit = apply_filters('oboxads_manual_init', $manualInit);

  $postId = get_queried_object_id();
  $domain = (isset($plugin->options['oboxads_domain']) ? $plugin->options['oboxads_domain'] :  '');
  
  $domain = apply_filters('oboxads_domain', $domain);

  if (isset($_GET['oboxads-domain'])) {
    $domain = $_GET['oboxads-domain'];
  } //if

  if ( $plugin->options['experiment_enabled'] ) {

    $expCookieValue = isset($_COOKIE['_gaexp']) ? 
      $_COOKIE['_gaexp'] : "";

    if ($expCookieValue !== "") {
      // remove GAX1.2 from _gaexp cookie
      $expCookieValue = preg_replace('/GAX\d+\.\d+\./', '', $expCookieValue);

      // if multiple experiements are assigned they will be separated by a !
      $experiments = explode('!', $expCookieValue);

      // take the last experiment (should only have one)
      // @todo handle multiple experiments
      $currentExperiment =  array_pop($experiments); 

      $parts = explode('.', $currentExperiment);

      //extract variant
      $variantId = array_pop($parts);
      
      // we dont care about expiration
      $expiration = array_pop($parts);

      // the rest is experimentId
      $expId = implode('.', $parts);

      $domain = "experiments/{$expId}/{$variantId}/{$domain}";
    } //if
  } //if

  if (is_home()) {
    $contentType = 'homepage';
  } elseif (is_category()) {
    $contentType = 'categories';
  } elseif (is_single()) {
    $contentType = 'articles';
  } elseif (is_archive()) {
    $contentType = 'archives';
  } else {
    $contentType = 'other';
  } //if

  $contentCategories = array();
  if ($plugin->options['taxonomy_enabled'] && is_single()) {
    $terms = get_the_terms(get_the_ID(), 'oboxads_content');    
    if (is_array($terms)) {
      foreach($terms as $term) {
        $key = $term->description;
        $contentCategories[$key] = array(
          'key' => $key,
          'name' => $term->name,
        );
      } //foreach
    } // if
  } //if
  $contentCategoriesJson = json_encode($contentCategories);

  if ($tagVersion === 'v4') {
    echo <<<HTML
      <!-- OBOXADS Begin -->
      <style type="text/css">
        .oadb-popup-container 
        {
          align-items: center;
          -webkit-box-align: center;
          display: none;
          background-color: rgba(51,51,51,.8);
          height: 100%;
          -webkit-box-pack: center;
          -webkit-justify-content: center;
          -ms-flex-pack: center;
          justify-content: center;
          left: 0;
          position: fixed;
          top: 0;
          width: 100%;
          z-index: 1000;
        }
        .oadb-popup-container h2
        {
          margin: 0;
          padding: 0;
        }
        .oadb-popup-container .oadb_content
        {
          max-width: 829px;
          background: #fff;
          left: 50%;
          max-width: 694px;
          position: absolute;
          top: 50%;
          -webkit-transform: translate(-50%,-50%);
          -ms-transform: translate(-50%,-50%);
          transform: translate(-50%,-50%);
          width: 85%;
        }

        .oadb-popup-container h2 {
          font-size: 2rem;
        }

        .oadb-popup-container button 
        {
          text-decoration: none;
        }
        
        .oadb-popup-container .oadb_show_tuto_btn
        {
          background: #000;
          color: white;
          font-size: 16px;
          text-transform: uppercase;
          padding: 7px 15px;
          border: none;
          border-radius: 0;
        }
        
        button.oadb_close_btn 
        {
            padding: 2px 5px;
            background-color: black;
            border: none;
            position: absolute;
            top: 10px;
            right: 10px;
            border-radius: 5px;
            color: #fff;
        }

        .oadb_content_warning.disabled 
        {
          display: none;
        }
        .oadb_content_warning .inner
        {
          padding: 60px;
        }
        .oadb-popup-container.active 
        {
          display: flex;
        }
        body.oadb-active
        {
          overflow: hidden;
        }
        .oadb-tutorial-tabs
        {
          display: flex;
          vertical-align: baseline;
        }
        .oadb-tutorial-tabs,
        .oadb-tutorial-tab-content
        {
          max-width: 560px;
          margin: 0 auto;
        }
        .oadb-popup-container .oadb_tutotrial
        {
          display: none;
          background: #f4f4f4;
          font-family: 'Arial', sans-serif;
        }
        .oadb-popup-container .oadb_tutotrial .oadb_content_tuto_header
        {
          padding: 20px;
          text-align: center;
        }

        .oadb-popup-container .oadb_tutotrial.active 
        {
          display: block;
        }

        .oadb-tutorial-tabs-content 
        {
          background: #fff;
        }

        .oadb-tutorial-tab
        {
          display: flex;
          justify-content: center;
          flex: 1;
          flex-direction: column;
          align-items: center;
          justify-content: flex-end;
          padding: 10px 5px;
          border-bottom: 2px solid transparent;
          cursor: pointer;
          vertical-align: baseline;
          background: transparent;
          text-align:center;
          font-size: 14px;
        }

        .oadb-tutorial-tabs-content li img {
          max-height: 19px;
          max-width: 19px;
          display: inline;
          vertical-align: middle;
        }

        .oadb-tutorial-tab.active {
          background-color: #fff;
          border-bottom: 2px solid #000;
        }

        .oadb-tutorial-tab span {
          margin-top: 5px;
          color: #959595;
        }

        .oadb-tutorial-tab.active span
        {
          color: #000;
          font-weight: bold;
        }

        .oadb-tutorial-tab-content
        {
          display: none;
          background-color: #fff;
          padding: 20px 20px 30px;
          min-height: 390px;
        }

        .oadb-tutorial-tab-content li {
          font-size: 16px;
          padding: 4px 0 0 40px;
          min-height: 27px;
          line-height: 1.3;
          list-style: none;
          margin: 0;
          position: relative;
        }

        .oadb-tutorial-tab-content li + li
        {
          margin-top: 10px;
        }

        .oadb-tutorial-tab-content li span {
          display: inline-flex;
          align-items: center;
          justify-content: center;
          width: 27px;
          height: 27px;
          color: #2b2b2b;
          padding: 1px 0 0 3px;
          background: #f1f1f1;
          border-radius: 50%;
          position: absolute;
          top: 0;
          left: 0;
        }

        .oadb-tutorial-tab-content .oadb-tuto-footer
        {
          text-align: center;
          margin-top: 20px;
        }

        .oadb-tutorial-tab-content .oadb-toolbar
        {
          width: 100%;
        }

        .oadb-tutorial-tab-content .oadb-tuto-footer button
        {
          padding: 8px 20px;
          border-radius: 5px;
          font-size: 14px;
          background: #000;
          color: #fff;
        }
        
        .oadb-tutorial-tab-content.active
        {
          display: block;
        }

        .oadb-overlay
        {
          padding: 60px 20px;
          font-weight: bold;
          color: #fff;
          text-align: center;
          font-size: 20px;
          background-color: red;
        }

        .entry-content.adboverlay
        {
          opacity: 0.07;
        }

        .overlay_whitelisted
        {
          font-size: 24px;
          font-weight: bold;
          color: red;
          background-color: white;
          padding: 10px 15px;
          cursor: pointer;
        }

        @media screen and (max-width: 767px) {
          .oadb-popup-container h2 {
            font-size: 20px;
          }
          .oadb-popup-container .oadb_tutotrial, .oadb-tutorial-tab-content, .oadb-tutorial-tab-content li, 
          .oadb-tutorial-tab, .oadb-tuto-footer button {
            font-size: 13px;
          }

          .oadb_content_tuto_header p {
            margin-bottom: 0;
            line-height: inherit;
          }

          .oadb-tutorial-tab-content
          {
            min-height: 300px;
          }
          .oadb-popup-container .oadb_content
          {
            width: 90%;
            max-height: 95%;
          }
          .oadb-tutorial-tab-content ol
          {
            margin: 0;
            padding: 0;
            border: 0;
            outline: 0;
            vertical-align: baseline;
            background: transparent;
          }
          .oadb-tutorial-tab img {
            max-height: 29px;
            max-width: 20px;
          }
        }

      </style>
      <script>
      (function (w,d,s,n,u,v) {
          var cs = d.getElementsByTagName(s)[0],
              ns = d.createElement(s),
              initDone = false;

          ns.async = true;
          ns.src = '{$baseURL}/{$tagVersion}/sites/'+ u +'.js?cb='+ new Date().getTime();
          w[n] = w[n] || [];
          w[n].blocked = null;
          w[n].init = function () {
            if (initDone) {
              return;
            }
            initDone = true
            cs.parentNode.insertBefore(ns, cs);
          }
      })(window, document, 'script', 'OBOXADSQ', '{$domain}');
      </script>
HTML;

    if ($manualInit !== true) {
    echo <<<HTML
      <script>
        OBOXADSQ.init()
      </script>
HTML;
    } // if
  } else if ($tagVersion === 'hybrid') {
    echo <<<HTML
      <!-- OBOXADS Begin -->
      <script>
      (function (w,d,s,n,u) {
          var cs = d.getElementsByTagName(s)[0],
              ns = d.createElement(s);
          var experimentId = sessionStorage.getItem('oboxads-experimentId') || '';

          if (experimentId === '') {
            experimentId = 'exp-' + (Math.floor(Math.random() * 10) + 1)
            sessionStorage.setItem('oboxads-experimentId', experimentId)
          } // if
          var v = 'v4';

          switch(experimentId) {
            case 'exp-1':
            case 'exp-2':
            case 'exp-3':
            case 'exp-4':
            case 'exp-5':
            case 'exp-6':
            case 'exp-7':
            case 'exp-8':
            case 'exp-9':
              v = 'v3';
              u += '-min';
              break;
          }
          ns.async = true;
          ns.src = '{$baseURL}/'+ v +'/sites/'+ u +'.js?cb='+ new Date().getTime();
          w[n] = w[n] || [];
          cs.parentNode.insertBefore(ns, cs);
      })(window, document, 'script', 'OBOXADSQ', '{$domain}');
      </script>
HTML;
  } else {
    echo <<<HTML
      <!-- OBOXADS Begin -->
      <script>
      (function (w,d,s,n,u) {
          var cs = d.getElementsByTagName(s)[0],
              ns = d.createElement(s);

          ns.async = true;
          ns.src = '{$baseURL}/{$tagVersion}/sites/'+ u +'-min.js?cb='+ new Date().getTime();
          w[n] = w[n] || [];
          cs.parentNode.insertBefore(ns, cs);
      })(window, document, 'script', 'OBOXADSQ', '{$domain}');
      </script>
HTML;
  } //if
  echo <<<HTML
    <script>
        OBOXADSQ.push({
            "postId": "{$postId}",
            "contentType": "{$contentType}",
            "startTime": new Date().getTime(),
            "contentCategories": {$contentCategoriesJson},
            "cmd": "config"
        });
    </script>
    <!-- OBOXADS End -->
HTML;
} // oboxads_head_script()

